
const util = {
    setTitle: (title) => {
        document.title = title;

        (function (t) {
            document.title = t;
            var i = document.createElement('iframe');
            i.src = '/favicon.ico';
            i.style.display = 'none';
            i.onload = function () {
                setTimeout(function () {
                    i.remove();
                }, 9)
            }
            document.body.appendChild(i);
        })(title)
    },
    reformParam(methodName,para) {
        var parameter = {}
        parameter['merchantid'] = '1'
        parameter['version'] = '1'
        parameter['sign_type'] = 'RSA'
        parameter['sign'] = '123'
        parameter['charset'] = 'UTF-8'
        parameter['method'] = methodName
        var context = ''
        for(var key in para){
            context += '&'+key+'='+para[key]
        }
        parameter['context'] = context
        return parameter
    },
    /**
     *
     * @param opt
     * view:页面名称
     * action:操作，如点击：click
     * label:事件描述
     * value：资源id
     */
    trackEvent: (opt) => {
      //  console.log('trackEvent')
        if (!opt) {
            return;
        }

        opt.view = opt.view || '';
        opt.action = opt.action || 'click';
        opt.label = opt.label || '';
        opt.value = opt.value || '';

        if (_czc && _czc.push) {
            _czc.push(['_trackEvent', opt.view, opt.action, opt.label, opt.value])
        }
    },

    trackPageview: (pathTo, pathFrom) => {
        if (_czc && _czc.push) {
            _czc.push(["_trackPageview", pathTo, pathFrom]);
        }
    },
    accountUrl:'skyforest.tencent.TencentController.signature',
    tokenUrl:'skyforest.mine.MineController.login.v093',
    adviserListUrl:'skyforest.dynatown.dynatownController.getDynatownList',
    chatUrl:'skyforest.dynatown.dynatownController.connect',
    dateFormat(date , fmt) {
        let ret
        const opt = {
            'y+': date.getFullYear().toString(), // 年
            'M+': (date.getMonth() + 1).toString(), // 月
            'd+': date.getDate().toString(), // 日
            'H+': date.getHours().toString(), // 时
            'm+': date.getMinutes().toString(), // 分
            's+': date.getSeconds().toString(), // 秒
            // 有其他格式化字符需求可以继续添加，必须转化成字符串
        }
        for (let k in opt) {
            ret = new RegExp('(' + k + ')').exec(fmt)
            if (ret) {
                fmt = fmt.replace(
                  ret[1],
                  ret[1].length == 1 ? opt[k] : opt[k].padStart(ret[1].length, '0')
                )
            }
        }
        return fmt
    },
    formatDatetime(val,format){
        const year = val.getFullYear();
        const month = val.getMonth()+1;
        const day = val.getDate();
        const hour = val.getHours();
        const minute = val.getMinutes();
        const second = val.getSeconds();
        return year+'-'+(month>9?month:'0'+month)+'-'+day+' '+hour+':'+(minute>9?minute:'0'+minute)+':'+(second>9?second:'0'+second);

    },
    formatDayTime(val){
        const year = val.getFullYear();
        const month = val.getMonth()+1;
        const day = val.getDate();
        const hour = val.getHours();
        const minute = val.getMinutes();
        const second = val.getSeconds();
        return year+'-'+(month>9?month:'0'+month)+'-'+day+' '+hour+':'+(minute>9?minute:'0'+minute);
    },
    formatTodayTime(val){
        const year = val.getFullYear();
        const month = val.getMonth()+1;
        const day = val.getDate();
        const hour = val.getHours();
        const minute = val.getMinutes();

        if(month==new Date().getMonth()+1&&day+1==new Date().getDate()){
            return '昨天'+hour+':'+(minute>9?minute:'0'+minute);
        }
        else if(month==new Date().getMonth()+1&&day==new Date().getDate()){

            return hour+':'+(minute>9?minute:'0'+minute);
        }else{
            return year+'-'+(month>9?month:'0'+month)+'-'+day+' '+hour+':'+(minute>9?minute:'0'+minute);
        }
    },

    /**
     * 计算天数
     * @param date1
     * @param date2
     * @returns {number}
     * @constructor
     */
    getNumberOfDays(date1,date2){//获得天数
        if(!date1 || !date2){
            return 0;
        }
        //date1：开始日期，date2结束日期
        var a1 = Date.parse(new Date(date1));
        var a2 = Date.parse(new Date(date2));
        var day = parseInt((a2-a1)/ (1000 * 60 * 60 * 24)) + 1;//核心：时间戳相减，然后除以天数
        return day
    },
	trackRequest(para, app = getApp()) {
	    if ((para.type && para.type.includes('Error'))) {
	        //所有报错埋点以及曝光埋点不再发送至服务器
	        return
	    }
		try {
			if (JSON.stringify(para.clkParams) === '"{}"' || JSON.stringify(para.clkParams) === "{}") {
				para.clkParams = '';
			}
			if (JSON.stringify(para.expand) === '"{}"' || JSON.stringify(para.expand) === "{}") {
				para.expand = '';
			}
	
			let _scene = (app.globalData.launchInfo && app.globalData.launchInfo.scene) ? app.globalData.launchInfo.scene : '';
			// console.log("app.globalData.launchInfo:" + JSON.stringify(app.globalData.launchInfo));
			let _fromParam = app.globalData.exchangedFromChannel ? JSON.parse(app.globalData.exchangedFromChannel) : {};
			//上一个页面
			let lastPage = getCurrentPages()[getCurrentPages().length-2] ? getCurrentPages()[getCurrentPages().length-2].$vm : null;
			let _pvLastPageName = lastPage ? lastPage.pvCurPageName : '';//上一页面名称
			let _pvLastPageParams =  (lastPage && lastPage.pvCurPageParams) ? lastPage.pvCurPageParams : '';//上一页面参数
			let _pvLastPagePath = lastPage ? (lastPage.route || lastPage.__route__) : '';//上一页面路径
			let currPage;
			// #ifdef H5
			if(para.pvId && para.pvId.includes('_close')){
				currPage = app.globalData.pageData;
			}
			else{
				currPage = getCurrentPages()[getCurrentPages().length - 1] ? getCurrentPages()[getCurrentPages().length - 1].$vm :null;
			}
			// #endif
			// #ifndef H5
			currPage = getCurrentPages()[getCurrentPages().length - 1] ? getCurrentPages()[getCurrentPages().length - 1].$vm :null;
			// #endif
			let _route = currPage ? (currPage.route || currPage.__route__) : "";
			let _pvCurPageName = currPage ? currPage.pvCurPageName : '';//当前页面名称
			let pvCurPageParams = "";//字符串string对象
			if(para.pvCurPageParams){//调用的时候传递进来的-先转为对象
				pvCurPageParams = typeof para.pvCurPageParams === 'object' ? para.pvCurPageParams : JSON.parse(para.pvCurPageParams)
			}else{
				let _tmp = (currPage && currPage.pvCurPageParams) ? currPage.pvCurPageParams : '{}';//获取当前页面的参数
				pvCurPageParams = typeof _tmp === 'string' ? JSON.parse(_tmp) : JSON.parse(JSON.stringify(_tmp))
			}
			//在页面参数里面手动添加path参数
			pvCurPageParams.brandId = config.brandId || "";
			pvCurPageParams.path = _route;
			pvCurPageParams.pageId = pvCurPageParams.pageId || currPage.pageId || "";
			pvCurPageParams.mobile = app.globalData.phone || "";
			pvCurPageParams.entryPageId = (lastPage && lastPage.pageId) ? lastPage.pageId : "";
			pvCurPageParams.entryPagePath = _pvLastPagePath;
			if(currPage && currPage.locusBehaviorName){//行为名称
				pvCurPageParams.locusBehaviorName = currPage.locusBehaviorName;
			}
			
			pvCurPageParams = JSON.stringify(pvCurPageParams);
			// if(para.clkId==='clk_2cmina_18'){
			// 	this.sendScoreShare()
			// }
			if (JSON.stringify(pvCurPageParams) === '"{}"' || JSON.stringify(pvCurPageParams) === "{}") {
				pvCurPageParams = '';
			}
			_fromParam["scene"] = _scene;
			_fromParam["appName"] = app.globalData.systemInfo ? app.globalData.systemInfo.appName : (app.$vm.$options.globalData.systemInfo.appName ||"");
			_fromParam['eventtime'] = Date.now();
			let houseID = "";
			if (currPage && currPage.houseId) {
				houseID = currPage.houseId;
			}
			if (currPage && (currPage.route == 'pages/shareCard/shareCard' || currPage.__route__ ==
					'pages/shareCard/shareCard')) {
				let enterPage = getCurrentPages()[getCurrentPages().length - 2] ? getCurrentPages()[getCurrentPages().length -
						2].$vm :
					null;
				if (enterPage && enterPage.houseId) {
					houseID = enterPage.houseId;
				}
			}
			console.log("houseID:" + houseID);
			let data = {
				userAgent: '',
				browserName: '',
				browserVersion: app.globalData.systemInfo ? app.globalData.systemInfo.SDKVersion : app.$vm.$options.globalData.systemInfo.SDKVersion,
				platform: 'miniapp', //是否来自小程序的标志
				fromPlatform: '', //来源平台，需要汤勇提供接口解析fromChannel存放
				reserve1: app.globalData.terminal, //来源平台，抖音百度微信
				reserve2: app.globalData.selectCityName || app.globalData.defaultProductCityName, //当前所在城市
				fromParam: JSON.stringify(_fromParam), //转发者秘钥
				deviceType: app.globalData.systemInfo ? app.globalData.systemInfo.model : (app.$vm.$options.globalData.systemInfo.SDKVersion || ""), //设备系统信息
				ip: app.globalData.ip || '', //ip地址
				cookieId: '',
				openId: app.globalData.openid || '', //openid
				customerId: (app.globalData.single && app.globalData.single.id) ? app.globalData.single.id : '', //用户id
				brandUserId: (app.globalData.single && app.globalData.single.id) ? app.globalData.single.id : '', //用户id
				createTime: this.formatTime(new Date()), //发送埋点时间
				uploadTime: this.formatTime(new Date()), //发送埋点时间
				product: app.globalData.projectName, //当前所在项目中文名称
				project: houseID, //当前项目id
				eventId: para.eventId || '', //埋点ID
				eventName: para.eventName || '', //埋点ID
				expand: typeof para.expand === 'object' ? JSON.stringify(para.expand) : para.expand, //扩展字段
				imTalkId: para.imTalkId || '', //IM对话编号
				imTalkType: para.imTalkType || '', //IM对话类型
				eventModuleDes: para.eventModuleDes || '', //模块描述信息
				eventInnerModuleId: para.eventInnerModuleId || '', //事件内部模块信息
				adviserId: para.adviserId || '', //顾问id
				clkDesPage: para.clkDesPage || _pvCurPageName || '', //点击前往的页面名称
				clkId: para.clkId || '', //点击ID
				clkName: para.clkName || '',
				pvId: para.pvId || '', //PV埋点ID
				clkParams: typeof para.clkParams === 'object' ? JSON.stringify(para.clkParams) : para.clkParams, //点击参数
				pvPageStayTime: para.pvPageStayTime || '',
				pvCurPageName: para.pvCurPageName || _pvCurPageName || '', //当前页面名称
				pvCurPageParams: pvCurPageParams, //当前页面参数
				pvLastPageName: para.pvLastPageName || _pvLastPageName || '', //上一页页面名称
				pvLastPageParams: para.pvLastPageParams || _pvLastPageParams || '', //上一页页面参数
				pvPageLoadTime: para.pvPageLoadTime || '', //加载时间
				type: para.type || '', //埋点类型
				longitude: app.globalData.longitude || '', //经度
				latitude: app.globalData.latitude || '', //纬度
				brandId: config.brandId, //集团id,
				reserve3: para.reserve3 || new Date().getTime(), //埋点触发时的时间戳
				reserve4: app.globalData.systemInfo ? app.globalData.systemInfo.deviceId : app.$vm.$options.globalData.systemInfo.deviceId,
			};
			// // #ifdef H5
			// data.openId = app.globalData.H5OpenId?app.globalData.H5OpenId:(app.globalData.openid||'');
			// data.customerId = app.globalData.H5CustomerId?app.globalData.H5CustomerId:((app.globalData.single && app.globalData.single.id) ? app.globalData.single.id : '');
			// data.brandUserId = data.customerId;
			// // #endif
			let timeNow = new Date().getTime();
			let session = uni.getStorageSync('sessionNumber') || timeNow;//session具体的值
			sessionTime = sessionTime || timeNow;//上一次发送埋点的时间
			if(currPage && (currPage.pvCurPageName == 'webviewPage')){//如果进入了H5-则锁定session
				sessionTime = timeNow;//上一次发送埋点的时间
			}
			if(currPage.pvCurPageName != 'liveRoom'){//页面不是直播，则有10分钟刷新逻辑
				if (timeNow - sessionTime > (10*60*1000)) {//判断当前要发送的埋点跟上次已经发送的埋点之间的时间差距
					session = timeNow;
					uni.setStorage({
						key: "sessionNumber",
						data: session
					})
				} else {//如果 相差不到10分钟，则session不更新，还是原来的session；这里可以加个判断 session不存在才赋值
					uni.setStorage({
						key: "sessionNumber",
						data: session
					})
				}
			}
			sessionTime = timeNow;//记录下当次埋点的发送时间
			data.session = data.brandUserId + '_' + session;//给当前的埋点加上session
			// #ifdef H5
			data.session = data.customerId + '_' + (app.globalData.session||session);//给当前的埋点加上session
			// #endif
			// app.globalData.session_id = data.session
			// app.globalData.sessionTime = timeNow;
			requestConfig('upload', data, true);
			// let param = ["SEND" +
			// 	"\nproject:" + "elab-marketing-system" + 
			// 	"\nmethod:" + 'POST' +
			// 	"\npath:" + '/behavior/brandMiniWeb/upload' +
			// 	"\ndestination:" + '/ws/remote/invoke' +
			// 	"\n\n" + JSON.stringify(data) +
			// 	"\u0000"
			// ];
			// app.wsSendOrder(param,data);//socket 消息发送
			console.warn("***mook***",(data.pvId || data.clkId || data.eventId),data.reserve3)
		} catch (e) {
			console.warn("***util.js-onError***", e);
		}
	},
	getSession(){//获取session
		let timeNow = new Date().getTime();
		let session = uni.getStorageSync('sessionNumber') || timeNow;//session具体的值
		uni.setStorage({
		    key: "sessionNumber",
		    data: session
		})
		return session;
	},
};

export default util;
